#version 450
//decals
struct PerFrameUniforms
{
    mat4 gViewMat4;
    mat4 gViewProjectionMat4;
    mat4 gCameraMat4;
    mat4 gCameraNoHeadTrackingMat4;
    mat4 gPrevViewProjectionMat4;
    mat4 gThisToPrevViewProjectionMat4;
    mat4 gInverseViewMat4;
    mat4 gInverseProjectionMat4;
    mat4 gInverseProjectionSCMat4;
    mat4 gInverseViewProjectionMat4;
    vec4 gInverseWorldUpMatVec4[3];
    vec3 gViewPositionVec3;
    float gfTime;
    vec3 gVREyeInfoVec3;
    float gfPrevTime;
    vec4 gClipPlanesVec4;
    vec4 gMBlurSettingsVec4;
    vec3 gDeJitterVec3;
    int giFrameIndex;
    vec4 gTaaSettingsVec4;
    vec4 gTessSettingsVec4;
    vec4 gShellsSettingsVec4;
    vec4 gFrameBufferSizeVec4;
    vec4 gFoVValuesVec4;
    vec4 gShadowSizeVec4;
    vec3 gShadowProjScaleVec3;
    int giDisableAmbientAllowed;
    vec4 gShadowFadeParamVec4;
};

struct CommonPerMeshUniforms
{
    vec4 gPlanetPositionVec4;
    mat4 gWorldMat4;
    mat4 gWorldNormalMat4;
    float gfFadeValue;
    vec4 gLightColourVec4;
    vec4 gLightCustomParamsVec4;
    mat4 gWorldMotionMat4;
    mat4 gInverseModelMat4;
};

struct CustomPerMaterialUniforms
{
    vec4 gImposterDataVec4;
    vec4 gTileBlendScalesVec4;
    vec4 gHueOverlayParamsVec4;
    vec4 gSaturationOverlayParamsVec4;
    vec4 gValueOverlayParamsVec4;
    vec4 gTerrainColour1Vec4;
    vec4 gTerrainColour2Vec4;
    vec4 gMaterialParamsVec4;
    vec4 gMaterialColourVec4;
    vec4 gMaterialSFXVec4;
    vec4 gMaterialSFXColVec4;
    vec4 gSunPositionVec4;
};

struct CustomPerMeshUniforms
{
    vec4 gUVScrollStepVec4;
    vec4 gCustomParams01Vec4;
    vec4 gCustomParams02Vec4;
    vec4 gObjectColourVec4;
};

struct UniformBuffer
{
    PerFrameUniforms mpPerFrame;
    CommonPerMeshUniforms mpCommonPerMesh;
    CustomPerMaterialUniforms mpCustomPerMaterial;
    CustomPerMeshUniforms mpCustomPerMesh;
};

//Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
layout(set = 0, binding = 45, std140) uniform Vk3DParams
{
    vec4 stereo;
    vec4 custom_params;
} vk3d_params;

layout(set = 0, binding = 0, std140) uniform lUniforms_BLK
{
    UniformBuffer lUniforms;
} _507;

layout(set = 1, binding = 1) uniform sampler2D gFadeNoiseMap;
layout(set = 1, binding = 2) uniform sampler2D gBufferMap;
layout(set = 1, binding = 0) uniform sampler2D gDiffuseMap;

layout(location = 0) in VertexBlock
{
    vec4 mTexCoordsVec4;
    vec4 mWorldPositionVec3_mfSpare;
    vec3 mTangentSpaceNormalVec3;
    vec4 mScreenSpacePositionVec4;
    flat vec3 mfFadeValueForInstance_mfLodIndex_mfShearMotionLength;
} In;

layout(location = 0) out vec4 out_color0;
layout(location = 1) out vec4 out_color1;
layout(location = 2) out vec4 out_color2;
layout(location = 3) out vec4 out_color3;

vec4 _1292;

void main()
{
    if (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x < 1.0)
    {
        vec3 _897 = floor(In.mWorldPositionVec3_mfSpare.xyz);
        vec3 _899 = fract(In.mWorldPositionVec3_mfSpare.xyz);
        vec4 _919 = textureLod(gFadeNoiseMap, (_897.xy + (vec2(37.0, 17.0) * _897.z)) + ((_899 * _899) * (vec3(3.0) - (_899 * 2.0))).xy, 0.0);
        float _920 = _919.x;
        if (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x < 0.0)
        {
            if ((1.0 - _920) > (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x + 2.0))
            {
                discard;
            }
        }
        else
        {
            if (_920 > In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x)
            {
                discard;
            }
        }
    }
    vec2 _961 = ((In.mScreenSpacePositionVec4.xy / vec2(In.mScreenSpacePositionVec4.w)) * 0.5) + vec2(0.5);
    vec2 _1064 = (_961 * 2.0) - vec2(1.0);
    vec4 _1257 = vec4(_1064.x, _1064.y, _1292.z, _1292.w);
    _1257.z = (((_507.lUniforms.mpPerFrame.gClipPlanesVec4.x * _507.lUniforms.mpPerFrame.gClipPlanesVec4.y) / (texture(gBufferMap, vec2(_961.x, 1.0 - _961.y)).x * _507.lUniforms.mpPerFrame.gClipPlanesVec4.y)) - _507.lUniforms.mpPerFrame.gClipPlanesVec4.x) / (_507.lUniforms.mpPerFrame.gClipPlanesVec4.y - _507.lUniforms.mpPerFrame.gClipPlanesVec4.x);
    
    _1257.x-=vk3d_params.stereo.x*(1-vk3d_params.stereo.y*_1257.z*10);
    
    vec4 _1259 = _1257;
    _1259.w = 1.0;
    vec4 _1074 = _507.lUniforms.mpPerFrame.gInverseViewProjectionMat4 * _1259;
    vec3 _990 = (_507.lUniforms.mpCommonPerMesh.gInverseModelMat4 * vec4((_1074.xyz / vec3(_1074.w)).xyz + _507.lUniforms.mpPerFrame.gViewPositionVec3, 1.0)).xyz + vec3(0.5);
    float _993 = 1.0 - _990.y;
    vec3 _1263 = _990;
    _1263.y = _993;
    float _996 = _990.x;
    bool _997 = _996 < 0.0;
    bool _1004;
    if (!_997)
    {
        _1004 = _996 >= 1.0;
    }
    else
    {
        _1004 = _997;
    }
    bool _1011;
    if (!_1004)
    {
        _1011 = _993 < 0.0;
    }
    else
    {
        _1011 = _1004;
    }
    bool _1018;
    if (!_1011)
    {
        _1018 = _993 >= 1.0;
    }
    else
    {
        _1018 = _1011;
    }
    bool _1025;
    if (!_1018)
    {
        _1025 = _990.z < 0.0;
    }
    else
    {
        _1025 = _1018;
    }
    bool _1032;
    if (!_1025)
    {
        _1032 = _990.z >= 1.0;
    }
    else
    {
        _1032 = _1025;
    }
    if (_1032)
    {
        discard;
    }
    vec4 _629 = texture(gDiffuseMap, _1263.xy);
    float _635 = _629.w * _507.lUniforms.mpCustomPerMaterial.gMaterialColourVec4.w;
    if (_635 < 9.9999997473787516355514526367188e-05)
    {
        discard;
    }
    vec4 _1277 = _1292;
    _1277.x = 0.0;
    vec4 _1279 = _1277;
    _1279.y = sqrt(_507.lUniforms.mpCustomPerMaterial.gMaterialParamsVec4.x * 0.5);
    vec4 _1281 = _1279;
    _1281.z = clamp(_507.lUniforms.mpCustomPerMaterial.gMaterialParamsVec4.z, 0.0, 1.0);
    vec4 _1283 = _1281;
    _1283.w = 0.0;
    out_color0 = vec4(_629.xyz, _635);
    out_color1 = vec4(0.0);
    out_color2 = vec4(0.0);
    out_color3 = _1283;
}


